#!/bin/bash


echo PROBAR ASI: ./upack.sh tar-1.22.summa 
echo Debe estar conectado a internet para bajar paquete tar
 

#    ututo-pack,  para empaquetar con el formato binario de ututo/gento desde DESTDIR

# ideas tomadas de 1) gentoo, 2) emerde, 3) de un script que alguien me paso en una lista hace mucho, no recuerdo su nombre
# xpak.py de gentoo, ultima version /usr/lib64/portage/pym/portage/xpak.py
#2010, Diego Saravia, diego.saravia@gmail.com, en lo que me toque AGPLv3+
#

#    Es Software Libre, Copyleft.
#    Publicado en forma gratuita y universalmente libre y copyleft
#    en el repositorio del psicro http://www.psicro.org
    
#    Copyright 2004 al 2008 (C)  por Diego Saravia, dsa@unsa.edu.ar - INENCO
#    bajo la AGPL 3.0 o superior

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU AFFERO GENERAL PUBLIC LICENSE as published 
#    by the Free Software Foundation, either version 3 of the License, or
#    any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.

#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#########################33 Funciones

# remplazar con source.sh y comain.sh, buscar bajar de gentoo
desempaqueta(){ 
        tar -zxvf $File -C "${BUILDDIR}"/work 
        # preveer tambien bz y otros
}

compilainstala(){
        # se puede hacer que el configure se ejecute parado en otro directorio si se quiere
        cd "${BUILDDIR}"/work/${PF}
	if test ! -e ./Makefile ; then
################################################### falta usar las opciones de compilacion de use y poner las variables abajo indicadas
	  ./configure --prefix=/usr
        fi
	make
        make DESTDIR=$DESTDIR install
}


has() {
        hasq "$@"
}

hasv() {
        if hasq "$@" ; then
                echo "$1"
                return 0
        fi
        return 1
}

hasq() {
        [[ " ${*:2} " == *" $1 "* ]]
}



filter_readonly_variables() {

READONLY_EBUILD_METADATA="DEFINED_PHASES DEPEND DESCRIPTION
	EAPI HOMEPAGE INHERITED IUSE KEYWORDS LICENSE
	PDEPEND PROVIDE RDEPEND RESTRICT SLOT SRC_URI"

READONLY_PORTAGE_VARS="D EBUILD EBUILD_PHASE \
	EBUILD_SH_ARGS EMERGE_FROM FILESDIR PORTAGE_BINPKG_FILE \
	PORTAGE_BIN_PATH PORTAGE_IUSE \
	PORTAGE_PYM_PATH PORTAGE_MUTABLE_FILTERED_VARS \
	PORTAGE_SAVED_READONLY_VARS PORTAGE_TMPDIR T WORKDIR"

PORTAGE_SAVED_READONLY_VARS="A CATEGORY P PF PN PR PV PVR"

PORTAGE_MUTABLE_FILTERED_VARS="AA HOSTNAME"


	local x filtered_vars
#	local 
readonly_bash_vars="DIRSTACK EUID FUNCNAME GROUPS
		PIPESTATUS PPID SHELLOPTS UID"
#	local 
filtered_sandbox_vars="SANDBOX_ACTIVE SANDBOX_BASHRC
		SANDBOX_DEBUG_LOG SANDBOX_DISABLED SANDBOX_LIB
		SANDBOX_LOG SANDBOX_ON"
	filtered_vars="${readonly_bash_vars} ${READONLY_PORTAGE_VARS}
		BASH_.* HISTFILE PATH POSIXLY_CORRECT"
	if hasq --filter-sandbox $* ; then
		filtered_vars="${filtered_vars} SANDBOX_.*"
	else
		filtered_vars="${filtered_vars} ${filtered_sandbox_vars}"
	fi
	if hasq --filter-features $* ; then
		filtered_vars="${filtered_vars} FEATURES"
	fi
	if ! hasq --allow-extra-vars $* ; then
		filtered_vars="
			${filtered_vars}
			${PORTAGE_SAVED_READONLY_VARS}
			${PORTAGE_MUTABLE_FILTERED_VARS}
		"
	fi

	python "${BIN_PATH}"/filter-bash-environment.py "${filtered_vars}"
}


save_ebuild_env() {
	(

		if hasq --exclude-init-phases $* ; then
			unset S _E_DOCDESTTREE_ _E_EXEDESTTREE_
			unset -f pkg_nofetch src_unpack src_prepare src_configure \
			src_compile src_test src_install
			if [[ -n $PYTHONPATH ]] ; then
				export PYTHONPATH=${PYTHONPATH/${PORTAGE_PYM_PATH}:}
				[[ -z $PYTHONPATH ]] && unset PYTHONPATH
			fi
		fi

		# misc variables set by bash
		unset BASH HOSTTYPE IFS MACHTYPE OLDPWD \
			OPTERR OPTIND OSTYPE PS4 PWD SHELL SHLVL

		# misc variables inherited from the calling environment
		unset COLORTERM DISPLAY EDITOR LESS LESSOPEN LOGNAME LS_COLORS PAGER \
			TERM TERMCAP USER

		# other variables inherited from the calling environment
		unset ECHANGELOG_USER GPG_AGENT_INFO \
		SSH_AGENT_PID SSH_AUTH_SOCK STY WINDOW XAUTHORITY

		# CCACHE and DISTCC config
		unset ${!CCACHE_*} ${!DISTCC_*}

		# There's no need to bloat environment.bz2 with internally defined
		# functions and variables, so filter them out if possible.

		for x in pkg_setup pkg_nofetch src_unpack src_prepare src_configure \
			src_compile src_test src_install pkg_preinst pkg_postinst \
			pkg_prerm pkg_postrm ; do
			unset -f default_$x _eapi{0,1,2}_$x
		done
		unset x

		unset -f dump_trace die diefunc quiet_mode vecho elog_base eqawarn elog \
			esyslog einfo einfon ewarn eerror ebegin _eend eend KV_major \
			KV_minor KV_micro KV_to_int get_KV unset_colors set_colors has \
			hasg hasgq hasv hasq qa_source qa_call \
			addread addwrite adddeny addpredict _sb_append_var \
			lchown lchgrp esyslog use usev useq has_version portageq \
			best_version use_with use_enable register_die_hook check_KV \
			keepdir unpack strip_duplicate_slashes econf einstall \
			dyn_setup dyn_unpack dyn_clean into insinto exeinto docinto \
			insopts diropts exeopts libopts \
			abort_handler abort_prepare abort_configure abort_compile \
			abort_test abort_install dyn_prepare dyn_configure \
			dyn_compile dyn_test dyn_install \
			dyn_preinst dyn_help debug-print debug-print-function \
			debug-print-section inherit EXPORT_FUNCTIONS newdepend newrdepend \
			newpdepend do_newdepend remove_path_entry \
			save_ebuild_env filter_readonly_variables preprocess_ebuild_env \
			source_all_bashrcs ebuild_main \
			ebuild_phase ebuild_phase_with_hooks \
			_ebuild_arg_to_phase _ebuild_phase_funcs default \
			_source_ebuild \
			${QA_INTERCEPTORS}

		# portage config variables and variables set directly by portage
		unset ACCEPT_LICENSE BAD BRACKET BUILD_PREFIX COLS \
			DISTCC_DIR DISTDIR DOC_SYMLINKS_DIR \
			EBUILD_EXIT_STATUS_FILE EBUILD_FORCE_TEST EBUILD_MASTER_PID \
			ECLASSDIR ECLASS_DEPTH ENDCOL FAKEROOTKEY \
			GOOD HILITE HOME IMAGE \
			LAST_E_CMD LAST_E_LEN LD_PRELOAD MISC_FUNCTIONS_ARGS MOPREFIX \
			NOCOLOR NORMAL PKGDIR PKGUSE PKG_LOGDIR PKG_TMPDIR \
			PORTAGE_ACTUAL_DISTDIR PORTAGE_ARCHLIST \
			PORTAGE_BASHRC PORTAGE_BASHRCS_SOURCED \
			PORTAGE_BINPKG_TAR_OPTS PORTAGE_BINPKG_TMPFILE PORTAGE_BUILDDIR \
			PORTAGE_COLORMAP PORTAGE_CONFIGROOT PORTAGE_DEBUG \
			PORTAGE_DEPCACHEDIR PORTAGE_GID PORTAGE_INST_GID \
			PORTAGE_INST_UID PORTAGE_LOG_FILE PORTAGE_MASTER_PID \
			PORTAGE_QUIET \
			PORTAGE_REPO_NAME PORTAGE_RESTRICT PORTAGE_UPDATE_ENV \
			PORTAGE_VERBOSE PORTAGE_WORKDIR_MODE PORTDIR \
			PORTDIR_OVERLAY ${!PORTAGE_SANDBOX_*} PREROOTPATH \
			PROFILE_PATHS PWORKDIR QA_INTERCEPTORS \
			RC_DEFAULT_INDENT RC_DOT_PATTERN RC_ENDCOL \
			RC_INDENTATION READONLY_EBUILD_METADATA READONLY_PORTAGE_VARS \
			ROOT ROOTPATH RPMDIR STARTDIR TMP TMPDIR USE_EXPAND \
			WARN XARGS _RC_GET_KV_CACHE

		# user config variables
		unset DOC_SYMLINKS_DIR INSTALL_MASK PKG_INSTALL_MASK

		set
		export
	)
}
####################################################################################################################


usage="
Usage: `basename $0` NOMBRE.summa SOURCE\n
Usage: `basename $0` -c CATEGORY NOMBRE.summa SOURCE\n
SUMMA es un archivo,  puede ser un ebuild, en cuyo caso usara algunas variables,\n
       dar la posicion relativa del archivo desde donde se ejecuta\n
SOURCE puede ser un tar.gz fuente o un directorio donde el paquete este instalado con make DESDTIR=dir install\n
Produce NOMBRE.tbz2"

#TEMP=`getopt -o hvc --long help,version,category -- "$@"`
# Note the quotes around `$TEMP': they are essential!
# eval set -- "$TEMP"



while getopts "hvc:" OPTIONS ; do
    case ${OPTIONS} in
        h|-help) 
           echo -e "${usage}"
           exit
           ;;
        v|-version) 
            echo "Version 0.1";
            exit
             ;;
        c|-category)
            CATEGORY=$OPTARG
            shift
            shift
          ;;
        *|-*)
            echo -e ${usage}
            exit 
         ;;
    esac
    #echo "$flag" $OPTIND $OPTARG
done

ESTOYEN=`pwd`
echo $ESTOYEN
# mejorar esto, sobre todo para el bin_path
BIN_PATH=`echo $0 | sed 's/\/upack.sh$//'`
# bin_pasth se pone como punto, usa el estoyen
BIN_PATH=$ESTOYEN


BUILDDIR=/tmp/upack
DESTDIR=${BUILDDIR}/image
mkdir -p $DESTDIR "${BUILDDIR}"/work "$BUILDDIR"/build-info  "${BUILDDIR}"/temp  

BINPKG="${ESTOYEN}.tar.bz2"



unset DEPEND RDEPEND PDEPEND IUSE



REPO_NAME=gentoo

##########################
CFLAGS="-O2"
CXXFLAGS="${CFLAGS}"
CHOST="i686-pc-linux-gnu"
ACCEPT_KEYWORDS=""
MAKEOPTS="-j1" 
INPUT_DEVICES="keyboard mouse evdev"
VIDEO_CARDS=""
FEATURES=""
LINGUAS="en es"
USE="-gtk -gnome qt3 qt4 kde dvd alsa cdr"

# son cambiadas si hay estos archivos:
source /etc/make.conf
source ${BIN_PATH}/make.conf
#####################################


if test "x$1" = x ; then
    echo -e ${usage}
    exit
  else
    COMI=`echo $1| grep '^\/'  `
    if test "x$COMI" = "x$EB" ; then
         EBUILD=$1
      else
         EBUILD=${ESTOYEN}/$1   
    fi
    PF=`basename $1|sed 's/\.ebuild$//'|sed 's/\.summa$//'`

    #PF nombre

    source "${EBUILD}" || die "error sourcing ebuild"
    
   
    if test -d "$2"; then
        DESTDIR=$2
    elif  test -f "$2"; then
        File=$2
        # esto es solo para facilitar su uso ahora
        desempaqueta
        compilainstala
     elif test -n "${SRC_URI}" ; then   
        wget -c ${SRC_URI} -P "${BUILDDIR}"/work
        File=`basename ${SRC_URI}`
        desempaqueta
        compilainstala
        #SRC_URI="http://ftp.gnu.org/gnu/tar/${P}.tar.bz2
     else
       echo "No hay fuente"
       exit;
     fi
fi

###  RESULTADO

UPKG="${ESTOYEN}/${PF}.tbz2"
	


if test "x${PF}.ebuild" = `basename $1` ; then
   	cp "${EBUILD}" "${BUILDDIR}"/build-info/${PF}.ebuild
    else
       echo "Construir EBUILD estandar  desde summa"

       # variables que deben estar en summa
       echo "# Copyleft AGPLv3+" > "${BUILDDIR}"/build-info/${PF}.ebuild
       echo "inherit flag-o-matic eutils" >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo DESCRIPTION=$DESCRIPTION >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo HOMEPAGE=$HOMEPAGE        >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo SRC_URI=$SRC_URI        >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo LICENCE=$LICENCE       >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo SLOT=$SLOT       >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo KETWORDS=$KEYWORDS       >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo IUSE=$IUSE       >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo RDEPEND=$REDEPEND       >>"${BUILDDIR}"/build-info/${PF}.ebuild
       echo DEPEND=$DEPEND       >>"${BUILDDIR}"/build-info/${PF}.ebuild
       cat $BIN_PATH/base.ebuild       >> "${BUILDDIR}"/build-info/${PF}.ebuild
fi 


#	if [ "${EBUILD_PHASE}" != "depend" ] ; then
#		RESTRICT=${PORTAGE_RESTRICT}
#		[[ -e $PORTAGE_BUILDDIR/.ebuild_changed ]] && \
#			rm "$PORTAGE_BUILDDIR/.ebuild_changed"
#	fi


	set -f
	if [ "${RDEPEND-unset}" == "unset" ] ; then
		export RDEPEND=${DEPEND}
		debug-print "RDEPEND: not set... Setting to: ${DEPEND}"
	fi

	# add in dependency info from eclasses
	IUSE="${IUSE} ${E_IUSE}"
	DEPEND="${DEPEND} ${E_DEPEND}"
	RDEPEND="${RDEPEND} ${E_RDEPEND}"
	PDEPEND="${PDEPEND} ${E_PDEPEND}"

############# quiza debiera compilar aqui


	unset ECLASS E_IUSE E_DEPEND E_RDEPEND E_PDEPEND
	set +f




 
	cd "${BUILDDIR}/build-info"
	set -f
#	local f x
	IFS=$' \t\n\r'
	for f in ASFLAGS CATEGORY CBUILD CC CFLAGS CHOST CTARGET CXX \
		CXXFLAGS DEFINED_PHASES DEPEND EXTRA_ECONF EXTRA_EINSTALL EXTRA_MAKE \
		FEATURES INHERITED IUSE LDFLAGS LIBCFLAGS LIBCXXFLAGS \
		LICENSE PDEPEND PF PKGUSE PROPERTIES PROVIDE RDEPEND RESTRICT SLOT \
		KEYWORDS HOMEPAGE SRC_URI DESCRIPTION; do
		x=$(echo -n ${!f})
		[[ -n $x ]] && echo "$x" > $f
	done
	echo "${USE}"       > USE
	echo "${EAPI:-0}"   > EAPI
	set +f

	# local variables can leak into the saved environment.
	unset f

	save_ebuild_env --exclude-init-phases | filter_readonly_variables \
		--filter-sandbox --allow-extra-vars > environment

	bzip2 -f9 environment



	[ -n "${REPO_NAME}" ]  && echo "${REPO_NAME}" > repository
#	if striped (ver como averiguamos) 
#	then
#		touch DEBUGBUILD
#	fi









	# Make sure $PWD is not ${D} so that we don't leave gmon.out files
	# in there in case any tools were built with -pg in CFLAGS.
      
#DESTDIR, que no sea donde estamos

#	install_mask "${PORTAGE_BUILDDIR}/image" "${PKG_INSTALL_MASK}"

#VER 
#PF nombre del paquete
#BUILDDIR /var/tmp/pakete/
#info en         ${BUILDDIR}"/build-info
#DESTDIR /var/tmp/pakete/image
#ACTUAL se para en  /var/tmp/pakete/temp




        cd ${BUILDDIR}/temp

	tar $tar_options -cf - $BINPGK_TAR_OPTS -C "${DESTDIR}" . | bzip2 -f > "$BINPKG"

	python "${BIN_PATH}"/upack.py --pack $BINPKG $UPKG ${BUILDDIR}/build-info
        # poner opcion al upak para añadir sobre si mismo, salida sobre salida estandar,de info  o paquete
        rm $BINPKG
#	local 
md5_hash=""
	if type md5sum &>/dev/null ; then
		md5_hash=$(md5sum "${UPKG}")
		md5_hash=${md5_hash%% *}
	elif type md5 &>/dev/null ; then
		md5_hash=$(md5 "${UPKG}")
		md5_hash=${md5_hash##* }
	fi
	[ -n "${md5_hash}" ] && \
		echo ${md5_hash} > "${BUILDDIR}"/build-info/BINPKGMD5



exit

###### no los uso

dyn_package() {
	# Make sure $PWD is not ${D} so that we don't leave gmon.out files
	# in there in case any tools were built with -pg in CFLAGS.
	cd "${T}"
	install_mask "${PORTAGE_BUILDDIR}/image" "${PKG_INSTALL_MASK}"
	local tar_options=""
	[[ $PORTAGE_VERBOSE = 1 ]] && tar_options+=" -v"
	# Sandbox is disabled in case the user wants to use a symlink
	# for $PKGDIR and/or $PKGDIR/All.
	export SANDBOX_ON="0"
	[ -z "${PORTAGE_BINPKG_TMPFILE}" ] && \
		PORTAGE_BINPKG_TMPFILE="${PKGDIR}/${CATEGORY}/${PF}.tbz2"
	mkdir -p "${PORTAGE_BINPKG_TMPFILE%/*}" || die "mkdir failed"
	tar $tar_options -cf - $PORTAGE_BINPKG_TAR_OPTS -C "${D}" . | \
		bzip2 -f > "$PORTAGE_BINPKG_TMPFILE"
	assert "failed to pack binary package: '$PORTAGE_BINPKG_TMPFILE'"
	PYTHONPATH=${PORTAGE_PYM_PATH}${PYTHONPATH:+:}${PYTHONPATH} \
	python -c "from portage import xpak; t=xpak.tbz2('${PORTAGE_BINPKG_TMPFILE}'); t.recompose('${PORTAGE_BUILDDIR}/build-info')"
	if [ $? -ne 0 ]; then
		rm -f "${PORTAGE_BINPKG_TMPFILE}"
		die "Failed to append metadata to the tbz2 file"
	fi
	local md5_hash=""
	if type md5sum &>/dev/null ; then
		md5_hash=$(md5sum "${PORTAGE_BINPKG_TMPFILE}")
		md5_hash=${md5_hash%% *}
	elif type md5 &>/dev/null ; then
		md5_hash=$(md5 "${PORTAGE_BINPKG_TMPFILE}")
		md5_hash=${md5_hash##* }
	fi
	[ -n "${md5_hash}" ] && \
		echo ${md5_hash} > "${PORTAGE_BUILDDIR}"/build-info/BINPKGMD5
	vecho ">>> Done."
	cd "${PORTAGE_BUILDDIR}"
	touch .packaged || die "Failed to 'touch .packaged' in ${PORTAGE_BUILDDIR}"
}

dyn_spec() {
	local sources_dir=/usr/src/rpm/SOURCES
	mkdir -p "${sources_dir}"
	tar czf "${sources_dir}/${PF}.tar.gz" \
		"${EBUILD}" "${FILESDIR}" || \
		die "Failed to create base rpm tarball."

	cat <<__END1__ > ${PF}.spec
Summary: ${DESCRIPTION}
Name: ${PN}
Version: ${PV}
Release: ${PR}
Copyright: GPL
Group: portage/${CATEGORY}
Source: ${PF}.tar.gz
Buildroot: ${D}
%description
${DESCRIPTION}

${HOMEPAGE}

%prep
%setup -c

%build

%install

%clean

%files
/
__END1__

}

dyn_rpm() {
	cd "${T}" || die "cd failed"
	local machine_name=$(uname -m)
	local dest_dir=/usr/src/rpm/RPMS/${machine_name}
	addwrite /usr/src/rpm
	addwrite "${RPMDIR}"
	dyn_spec
	rpmbuild -bb --clean --rmsource "${PF}.spec" || die "Failed to integrate rpm spec file"
	install -D "${dest_dir}/${PN}-${PV}-${PR}.${machine_name}.rpm" \
		"${RPMDIR}/${CATEGORY}/${PN}-${PV}-${PR}.rpm" || \
		die "Failed to move rpm"
}

if [ -n "${MISC_FUNCTIONS_ARGS}" ]; then
	source_all_bashrcs
	[ "$PORTAGE_DEBUG" == "1" ] && set -x
	for x in ${MISC_FUNCTIONS_ARGS}; do
		${x}
	done
fi

[ -n "${EBUILD_EXIT_STATUS_FILE}" ] && \
	touch "${EBUILD_EXIT_STATUS_FILE}" &>/dev/null

:




dyn_package() {
        cd "${PORTAGE_BUILDDIR}/image"
        install_mask "${PORTAGE_BUILDDIR}/image" ${PKG_INSTALL_MASK}
        local pkg_dest="${PKGDIR}/All/${PF}.tbz2"
        local pkg_tmp="${PKGDIR}/All/${PF}.tbz2.$$"
        # Sandbox is disabled in case the user wants to use a symlink
        # for $PKGDIR and/or $PKGDIR/All.
        export SANDBOX_ON="0"
        tar cpvf - ./ | bzip2 -f > "${pkg_tmp}" || die "Failed to create tarball"
        cd ..
        python -c "import xpak; t=xpak.tbz2('${pkg_tmp}'); t.recompose('${PORTAGE_BUILDDIR}/build-info')"
        if [ $? -ne 0 ]; then
                rm -f "${pkg_tmp}"
                die "Failed to append metadata to the tbz2 file"
        fi
        mv -f "${pkg_tmp}" "${pkg_dest}" || die "Failed to move tbz2 to ${pkg_dest}"
        ln -sf "../All/${PF}.tbz2" "${PKGDIR}/${CATEGORY}/${PF}.tbz2" || die "Failed to create symlink in ${PKGDIR}/${CATEGORY}"
        vecho ">>> Done."
        cd "${PORTAGE_BUILDDIR}"
        touch .packaged || die "Failed to 'touch .packaged' in ${PORTAGE_BUILDDIR}"
}







_source_ebuild() {

         # aca carga profile.bashrc desde /usr/portage/profiles
         #source_all_bashrcs en ebuild.sh

	# *DEPEND and IUSE will be set during the sourcing of the ebuild.
	# In order to ensure correct interaction between ebuilds and
	# eclasses, they need to be unset before this process of
	# interaction begins.

	[[ -n $EAPI ]] || EAPI=0

	# alphabetically ordered by $EBUILD_PHASE value
	local f valid_phases
	case "$EAPI" in
		0|1)
			valid_phases="src_compile pkg_config pkg_info src_install
				pkg_nofetch pkg_postinst pkg_postrm pkg_preinst pkg_prerm
				pkg_setup src_test src_unpack"
			;;
		*)
			valid_phases="src_compile pkg_config src_configure pkg_info
				src_install pkg_nofetch pkg_postinst pkg_postrm pkg_preinst
				src_prepare pkg_prerm pkg_setup src_test src_unpack"
			;;
	esac

	DEFINED_PHASES=
	for f in $valid_phases ; do
		if declare -F $f >/dev/null ; then
			f=${f#pkg_}
			DEFINED_PHASES+=" ${f#src_}"
		fi
	done
	[[ -n $DEFINED_PHASES ]] || DEFINED_PHASES=-

	# This needs to be exported since prepstrip is a separate shell script.
	[[ -n $QA_PRESTRIPPED ]] && export QA_PRESTRIPPED
}




#"${BUILDDIR}"/work/${PF}

#	local tar_options=""
#	[[ $PORTAGE_VERBOSE = 1 ]] && tar_options+=" -v"
#	touch .packaged || die "Failed to 'touch .packaged' in ${PORTAGE_BUILDDIR}"
#		rm -f "${PORTAGE_BUILDDIR}/.installed"
#	vecho ">>> Done."
#	elif [[ -e $PORTAGE_BUILDDIR/.installed ]] ; then#
#		vecho ">>> It appears that '${PF}' is already installed; skipping."
#		vecho ">>> Remove '${PORTAGE_BUILDDIR}/.installed' to force install."
#		return 0
#	fi
#	trap "abort_install" SIGINT SIGQUIT
#	rm -rf "${BUILDDIR}/image"
#	mkdir "${BUILDDIR}/image"


#	[ -z "$BUILDDIR" ] && die "${FUNCNAME}: BUILDDIR is unset"
#	if [ -d "${S}" ]; then
#		cd "${S}"
#	else
#		cd "${WORKDIR}"
#	fi
#	echo "Installar ${PF} into ${D} category ${CATEGORY}"
	#our custom version of libtool uses $S and $D to fix
	#invalid paths in .la files
#	export S D
	#some packages uses an alternative to $S to build in, cause
	#our libtool to create problematic .la files
#	export PWORKDIR="$WORKDIR"
#
	# Reset exeinto(), docinto(), insinto(), and into() state variables
	# in case the user is running the install phase multiple times
	# consecutively via the ebuild command.
#	export DESTTREE=/usr
#	export INSDESTTREE=""
#	export _E_EXEDESTTREE_=""
#	export _E_DOCDESTTREE_=""
#
#	ebuild_phase src_install
#	touch "${PORTAGE_BUILDDIR}/.installed"
#	vecho ">>> Completed installing ${PF} into ${D}"
#	vecho
#	ebuild_phase post_src_install


# Hardcoded bash lists are needed for backward compatibility with
# <portage-2.1.4 since they assume that a newly installed version
# of ebuild.sh will work for pkg_postinst, pkg_prerm, and pkg_postrm
# when portage is upgrading itself.



# Variables that portage sets but doesn't mark readonly.
# In order to prevent changed values from causing unexpected
# interference, they are filtered out of the environment when
# it is saved or loaded (any mutations do not persist).

# @FUNCTION: filter_readonly_variables
# @DESCRIPTION: [--filter-sandbox] [--allow-extra-vars]
# Read an environment from stdin and echo to stdout while filtering variables
# with names that are known to cause interference:
#
#   * some specific variables for which bash does not allow assignment
#   * some specific variables that affect portage or sandbox behavior
#   * variable names that begin with a digit or that contain any
#     non-alphanumeric characters that are not be supported by bash
#
# --filter-sandbox causes all SANDBOX_* variables to be filtered, which
# is only desired in certain cases, such as during preprocessing or when
# saving environment.bz2 for a binary or installed package.
#
# --filter-features causes the special FEATURES variable to be filtered.
# Generally, we want it to persist between phases since the user might
# want to modify it via bashrc to enable things like splitdebug and
# installsources for specific packages. They should be able to modify it
# in pre_pkg_setup() and have it persist all the way through the install
# phase. However, if FEATURES exist inside environment.bz2 then they
# should be overridden by current settings.
#
# ---allow-extra-vars causes some extra vars to be allowd through, such
# as ${PORTAGE_SAVED_READONLY_VARS} and ${PORTAGE_MUTABLE_FILTERED_VARS}.
#
# In bash-3.2_p20+ an attempt to assign BASH_*, FUNCNAME, GROUPS or any
# readonly variable cause the shell to exit while executing the "source"
# builtin command. To avoid this problem, this function filters those
# variables out and discards them. See bug #190128.



# ahora no lo uso, cuando se trate de producir paquetes quizas si
# @FUNCTION: preprocess_ebuild_env
# @DESCRIPTION:
# Filter any readonly variables from ${T}/environment, source it, and then
# save it via save_ebuild_env(). This process should be sufficient to prevent
# any stale variables or functions from an arbitrary environment from
# interfering with the current environment. This is useful when an existing
# environment needs to be loaded from a binary or installed package.
preprocess_ebuild_env() {
	local filter_opts=""
	if [ -f "${T}/environment.raw" ] ; then
		# This is a signal from the python side, indicating that the
		# environment may contain stale SANDBOX_{DENY,PREDICT,READ,WRITE}
		# and FEATURES variables that should be filtered out. Between
		# phases, these variables are normally preserved.
		filter_opts="--filter-sandbox --filter-features ${filter_opts}"
	fi
	filter_readonly_variables ${filter_opts} < "${T}"/environment \
		> "${T}"/environment.filtered || return $?
	unset filter_opts
	mv "${T}"/environment.filtered "${T}"/environment || return $?
	rm -f "${T}/environment.success" || return $?
	# WARNING: Code inside this subshell should avoid making assumptions
	# about variables or functions after source "${T}"/environment has been
	# called. Any variables that need to be relied upon should already be
	# filtered out above.
	(
		export SANDBOX_ON=1
		source "${T}/environment" || exit $?
		# We have to temporarily disable sandbox since the
		# SANDBOX_{DENY,READ,PREDICT,WRITE} values we've just loaded
		# may be unusable (triggering in spurious sandbox violations)
		# until we've merged them with our current values.
		export SANDBOX_ON=0

		# It's remotely possible that save_ebuild_env() has been overridden
		# by the above source command. To protect ourselves, we override it
		# here with our own version. ${PORTAGE_BIN_PATH} is safe to use here
		# because it's already filtered above.
		source "${PORTAGE_BIN_PATH}/isolated-functions.sh" || exit $?

		# Rely on save_ebuild_env() to filter out any remaining variables
		# and functions that could interfere with the current environment.
		save_ebuild_env || exit $?
		touch "${T}/environment.success" || exit $?
	) > "${T}/environment.filtered"
	local retval
	if [ -e "${T}/environment.success" ] ; then
		filter_readonly_variables < \
			"${T}/environment.filtered" > "${T}/environment"
		retval=$?
	else
		retval=1
	fi
	rm -f "${T}"/environment.{filtered,raw,success}
	return ${retval}
}


exit
